'''A Class for D&D 3.5 Mod'''

import es, dnds, popuplib, random, math
from dnds import dnds

def load():
    dnds.addClass('Fighter', dnds.ShotGuns+dnds.SMGs+dnds.Grenades+dnds.Pistols+dnds.Rifles+['scout','knife'])

    fighterinfo = popuplib.create('fighterinformation')
    fighterinfo.addline('-{ D&D CS:S - Fighter }-')
    fighterinfo.addline(' Weapons: Shotguns, SMGs, Grenades, Pistols, Rifles, and Scout')
    fighterinfo.addline(' Toughness - Bonus Health')
    fighterinfo.addline(' Minus 10% Speed')
    fighterinfo.addline('-> 1. Powers 1-10')
    fighterinfo.addline('-> 2. Powers 10-20')
    fighterinfo.addline('-> 7. Play as a Fighter')
    fighterinfo.addline('-> 8. Back')
    fighterinfo.addline('0. Exit')
    fighterinfo.submenu(8, 'classinfo 1')
    fighterinfo.submenu(1, 'fighterpwrsinfo1')
    fighterinfo.submenu(2, 'fighterpwrsinfo2')
    fighterinfo.menuselect = fighterMenuSelect
    dnds.addClassInformation('Fighter', 'fighterinformation')

    pwrsinfo = popuplib.create('fighterpwrsinfo1')
    pwrsinfo.addline('-{ Fighter Powers - Lvls 1-10 }-')
    pwrsinfo.addline(' Lvl 2: Weapon Focus - Bonus Damage')
    pwrsinfo.addline(' Lvl 4: Heavy Blow - Chance to Drug')
    pwrsinfo.addline(' Lvl 6: Toughness - Bonus Health')
    pwrsinfo.addline(' Lvl 8: Run - Gain 15% Speed')
    pwrsinfo.addline(' Lvl 10: Point Blank Shot - +40% Damage at a Close Range')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'fighterinformation')

    pwrsinfo = popuplib.create('fighterpwrsinfo2')
    pwrsinfo.addline('-{ Fighter Powers - Lvls 10-20 }-')
    pwrsinfo.addline(' Lvl 12: Cleave - Your attack damages those around the target')
    pwrsinfo.addline(' Lvl 14: Exotic Weapon - Gain the use of the AWP')
    pwrsinfo.addline(' Lvl 16: Deflect Bullets - Have a chance to block attacks')
    pwrsinfo.addline(' Lvl 18: Power Critical - Chance to deal double damage')
    pwrsinfo.addline(' Lvl 20: Stunning Blow - Have a chance to stun your victim')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'fighterinformation')

def fighterMenuSelect(userid, choice, popupid):
    if choice == 7:
        Key = dnds.getPlayer(userid)
        Key['delayed']['class'] = 'Fighter'
        es.tell(userid, '#multi', 'You will be a Fighter once the round ends')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isClass(userid, 'Fighter'):
        level = dnds.getLevel(userid, 'Fighter')
        dnds.Health(userid, 15)
        if level >= 2:
            Key['buff'] = .1
        if level >= 6:
            dnds.Health(userid, 15)
        if level >= 8:
            dnds.Speed(userid, .15)
        if level >= 14:
            Key['extra weapons'].append('awp')
        if level >= 16:
            Key['dodge percent'] += 10
            Key['dodge max damage'] = 100

def player_hurt(ev):
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    damage = int(float(ev['dmg_health']))
    if attacker:
        if dnds.isClass(attacker, 'Fighter'):
            level = dnds.getLevel(attacker, 'Fighter')
            x1,y1,z1 = es.getplayerlocation(attacker)
            x2,y2,z2 = es.getplayerlocation(userid)
            if level >= 4:
                if not random.randrange(8):
                    es.tell(attacker, '#multi', 'You have blurred the vision of %s with a heavy blow!'%es.getplayername(userid))
                    es.server.queuecmd('est_drug %s 2'%userid)
            if level >= 10:
                if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 180:
                    dnds.Damage(userid, attacker, damage*.4)
            if level >= 12:
                mylist = []
                for player in es.getUseridList():
                    if es.getplayerteam(player) == es.getplayerteam(userid):
                        if not es.getplayerprop(player, "CBasePlayer.pl.deadflag"):
                            if player != userid:
                                x3,y3,z3 = es.getplayerlocation(player)
                                if math.sqrt(math.pow(x3-x2, 2) + math.pow(y3-y2, 2) + math.pow(z3-z2, 2)) <= 180:
                                    mylist.append(player)
                if len(mylist):
                    dnds.Damage(random.choice(mylist), attacker, damage)
            if level >= 18:
                if not random.randrange(20):
                    es.tell(attacker, '#multi', 'You have dealt double damage with a critical hit!')
                    dnds.Damage(userid, attacker, damage)
            if level >= 20:
                if not random.randrange(12):
                    es.tell(attacker, '#multi', 'You have stunned %s'%es.getplayername(userid))
                    dnds.Stun(userid, 2)

