'''A Class for D&D 3.5 Mod

Notes -
    Animate dead code is run from the Cleric.py'''

import es, dnds, popuplib, random, gamethread, math
from dnds import dnds

SpellCommands = ['blast', 'beshadowed', 'repel', 'hell', 'shadow']

def load():
    dnds.addClass('Warlock', dnds.Pistols+['ump45','mac10', 'tmp', 'knife'])

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/SubScripts/Warlock/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/SubScripts/Warlock/%s'%command)

    warlockinfo = popuplib.create('warlockinformation')
    warlockinfo.addline('-{ D&D CS:S - Warlock }-')
    warlockinfo.addline(' Weapons: Pistols, UMP, TMP, and Mac10')
    warlockinfo.addline(' Enter \'cast\' into chat for a casting menu')
    warlockinfo.addline(' Or enter the (keyword) listed to directly cast a spell')
    warlockinfo.addline('-> 1. Passive Powers')
    warlockinfo.addline('-> 2. Casting Powers')
    warlockinfo.addline('-> 7. Play as a Warlock')
    warlockinfo.addline('-> 8. Back')
    warlockinfo.addline('0. Exit')
    warlockinfo.submenu(8, 'classinfo 1')
    warlockinfo.submenu(1, 'warlockpwrsinfo1')
    warlockinfo.submenu(2, 'warlockpwrsinfo2')
    warlockinfo.menuselect = warlockMenuSelect
    dnds.addClassInformation('Warlock', 'warlockinformation')

    pwrsinfo = popuplib.create('warlockpwrsinfo1')
    pwrsinfo.addline('-{ Warlock Passive Powers }-')
    pwrsinfo.addline(' Lvl 3: Damage Reduction - 10% DR')
    pwrsinfo.addline(' Lvl 7: Leaps and Bounds - High Jumping')
    pwrsinfo.addline(' Lvl 11: Fiendish Resilience - Gain Fast Healing')
    pwrsinfo.addline(' Lvl 15: Damage Reduction - 10% Damage Reduction')
    pwrsinfo.addline(' Lvl 19: Fiendish Resilience - Gain Fast Healing++')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'warlockinformation')

    pwrsinfo = popuplib.create('warlockpwrsinfo2')
    pwrsinfo.addline('-{ Warlock Casting Powers }-')
    pwrsinfo.addline(' Lvl 1: Eldritch - Damage your target (blast)')
    pwrsinfo.addline(' Lvl 5: Beshadowed - Damage and blind target (beshadowed)')
    pwrsinfo.addline(' Lvl 9: The Dead Walk - Raise an ally as a zombie (500$) (animate)')
    pwrsinfo.addline(' Lvl 13: Repelling - Damage and knock back those around you (repel)')
    pwrsinfo.addline(' Lvl 17: Hellrime - Damage and slow your target and those around them (hell)')
    pwrsinfo.addline(' Lvl 20: Shadow Walk - Become transparent and gain increased speed (shadow)')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'warlockinformation')

    warlockcast = popuplib.create('Warlockcast')
    warlockcast.addline('-{ Warlock Cast }-')
    warlockcast.addline('-> 1. Eldritch Blast')
    warlockcast.addline('-> 2. Beshadowed Blast')
    warlockcast.addline('-> 3. The Dead Walk')
    warlockcast.addline('-> 4. Repelling Blast')
    warlockcast.addline('-> 5. Hellrime Blast')
    warlockcast.addline('-> 6. Shadow Walk')
    warlockcast.addline('-> 9. Prestige Castings')
    warlockcast.addline('0. Exit')
    warlockcast.prepuser = warlockCastPrep
    warlockcast.menuselect = warlockCast

    dnds.Commands['cast']['Classes'].append('Warlock')

def warlockMenuSelect(userid, choice, popupid):
    if choice == 7:
        Key = dnds.getPlayer(userid)
        Key['delayed']['class'] = 'Warlock'
        es.tell(userid, '#multi', 'You will be a Warlock once the round ends')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isClass(userid, 'Warlock'):
        level = dnds.getLevel(userid, 'Warlock')
        if level >= 3:
            Key['damage reduction'] += .1
        if level >= 7:
            Key['jump'] += .3
        if level >= 15:
            Key['damage reduction'] += .1
        if level >= 11 and level < 19:
            dnds.Regeneration(userid, 3, 1)
        elif level >= 19:
            dnds.Regeneration(userid, 3, 2)

def blast():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 0, 1, 'Warlock'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, blastRun, (userid))

def blastRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 2000:
            dnds.Beam1(userid, target, 1, 0, 0, 255)
            if not dnds.spellResistance(target, dnds.getLevel(userid, 'Warlock')):
                damage = random.randrange(15, 45, 5)
                dnds.Damage(target, userid, damage)
                es.tell(target, '#multi', 'You have been hit by a eldritch blast')
                es.tell(userid, '#multi', 'You have hit %s with a eldritch blast'%es.getplayername(target))
            else:
                damage = 0
                es.tell(userid, '#multi', '%s has resisted your eldritch blast'%es.getplayername(target))
            Key = dnds.getPlayer(userid)
            if 'sniper' in Key:
                if Key['sniper']:
                    if (Key['stealth on'] and not Key['stealth delay']) or Key['Invisibility']:
                        es.event('initialize', 'sneak_attack')
                        es.event('setint',     'sneak_attack', 'userid', target)
                        es.event('setint',     'sneak_attack', 'attacker', userid)
                        es.event('setint',     'sneak_attack', 'damage', damage)
                        es.event('fire',       'sneak_attack')
                        Key['sniper'] -= 1
            dnds.spellDelay(userid, 3)

def beshadowed():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 0, 5, 'Warlock'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, beshadowedRun, (userid))

def beshadowedRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 2000:
            dnds.Beam1(userid, target, 1, 155, 0, 155)
            if not dnds.spellResistance(target, dnds.getLevel(userid, 'Warlock')):
                dnds.Blind(target, 6)
                dnds.Damage(target, userid, random.randrange(10, 60, 10))
                es.tell(target, '#multi', 'You have been hit by a beshadowed eldritch blast')
                es.tell(userid, '#multi', 'You have hit %s with a beshadowed eldritch blast'%es.getplayername(target))
            else:
                es.tell(userid, '#multi', '%s has resisted your beshadowed eldritch blast'%es.getplayername(target))
            dnds.spellDelay(userid, 6)

def repel():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 0, 13, 'Warlock'):
        x1,y1,z1 = es.getplayerlocation(userid)
        dnds.spellDelay(userid, 7)
        for player in es.getUseridList():
            if es.getplayerteam(userid) != es.getplayerteam(player):
                x2,y2,z2 = es.getplayerlocation(player)
                if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 360:
                    dnds.Beam3(userid, player, 1, 200, 0, 0)
                    if not dnds.spellResistance(player, dnds.getLevel(userid, 'Warlock')):
                        dnds.Damage(player, userid, random.randrange(20, 80, 10))
                        es.tell(player, '#multi', 'You have been hit by a Repelling Blast')
                        es.tell(userid, '#multi', 'You have hit %s with a Repelling Blast'%es.getplayername(player))
                        x, y, z = es.getplayerlocation(userid)
                        knockback = 60
                        es.setplayerprop(player, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * knockback, y * knockback, z * knockback))

def hell():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 0, 17, 'Warlock'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, hellRun, (userid))

def hellRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 2000:
            dnds.Beam3(userid, target, 1, 0, 0, 255)
            dnds.spellDelay(userid, 8)
            for player in es.getUseridList():
                if not es.getplayerprop(player, "CBasePlayer.pl.deadflag"):
                    x3,y3,z3 = es.getplayerlocation(player)
                    if math.sqrt(math.pow(x3-x2,2)+math.pow(y3-y2,2)+math.pow(z3-z2,2)) <= 240:
                        if not dnds.spellResistance(player, dnds.getLevel(userid, 'Warlock')):
                            if target != player:
                                dnds.Beam2(target, player, 1, 0, 0, 255)
                            dnds.Speed(player, -.2, delay=8)
                            dnds.Damage(player, userid, random.randrange(20, 80, 10))
                            es.tell(player, '#multi', 'You have been hit by a hellrime eldritch blast!')
                            es.tell(userid, '#multi', 'You have hit %s with a hellrime eldritch blast'%es.getplayername(player))

def shadow():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 0, 20, 'Warlock'):
        es.tell(userid, '#multi', 'You have entered a shadow walk state, you are quick, harder to see, and can dodge')
        Key = dnds.getPlayer(userid)
        Key['dodge percent'] += 20
        Key['dodge max damage'] += 100
        dnds.spellDelay(userid, 16)
        dnds.Speed(userid, .3, delay=8)
        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 30 1'%userid)
        dnds.Delayed(userid, 8, shadowOff, (userid))

def shadowOff(userid):
    es.tell(userid, '#multi', 'Your shadow walk has worn off...')
    es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)
    Key = dnds.getPlayer(userid)
    Key['dodge percent'] -= 20
    Key['dodge max damage'] -= 100

def warlockCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'blast')
    elif choice == 2:
        es.cexec(userid, 'beshadowed')
    elif choice == 3:
        es.cexec(userid, 'animate')
    elif choice == 4:
        es.cexec(userid, 'repel')
    elif choice == 5:
        es.cexec(userid, 'hell')
    elif choice == 6:
        es.cexec(userid, 'shadow')
    elif choice == 9 and dnds.Bank(userid)['prestige']:
        dnds.popupSend('%scast'%dnds.Bank(userid)['prestige'], userid)

def warlockCastPrep(userid, popupid):
    popup = popuplib.find('Warlockcast')
    level = dnds.getLevel(userid, 'Warlock')
    Key = dnds.getPlayer(userid)
    ID = dnds.Bank(userid)
    prestige = ID['prestige']
    if level < 5:
        popup.modline(3, '')
    else:
        popup.modline(3, '-> 2. Beshadowed Blast')
    if level < 9:
        popup.modline(4, '')
    else:
        popup.modline(4, '-> 3. The Dead Walk')
    if level < 13:
        popup.modline(5, '')
    else:
        popup.modline(5, '-> 4. Repelling Blast')
    if level < 17:
        popup.modline(6, '')
    else:
        popup.modline(6, '-> 5. Hellrime Blast')
    if level < 20:
        popup.modline(7, '')
    else:
        popup.modline(7, '-> 6. Shadow Walk')
    if prestige:
        popup.modline(8, '-> 9. Prestige Castings')
    else:
        popup.modline(8, '')

